#!/usr/bin/perl -w

# Copyright - Rolf Poser - rolf@stasolutions.co.za
# 19 May 2004 under the GPL license agreement!
#
# Version 0.4 - PLEASE SEE README.txt for more information.
#
# USAGE:
#
# perl unix_apachestats.pl <hostname> 
#
# <hostname> is optional and can be an IP address or host name.
#            If none is given, "localhost" is assumed.
#            The cacti configuration should normally take care of this..
#

#
# YOU SHOULDN"T NEED TO CHANGE ANYTHING BEYOND THIS POINT..
#

# Ensure that we have access to the right modules:

use strict;
use LWP::UserAgent;
use HTTP::Request;
use HTTP::Response;

# First get hold of any supplied hostname, otherwise set to "localhost"

my $hostname = $ARGV[0];

chomp $hostname;

if ($hostname eq '') {
        $hostname = "localhost";
}

# Set the query URL:

my $fullURL = "http:\/\/".$hostname."\/server-status?auto";

# Define a user agent:

my $userAgent = new LWP::UserAgent;
$userAgent->agent("ApacheStats/0.4 ");

# Run the query:

my $request = new HTTP::Request('GET', $fullURL);
my $response = $userAgent->request($request);

# Parse the output and put out the stats to STDOUT:

if ($response->is_success) {
	$response->content =~ /Total Accesses: (.*)/; 
	print "apache_total_hits:".$1." "; 
	$response->content =~ /Total kBytes: (.*)/; 
	print "apache_total_kbytes:".$1." ";
	$response->content =~ /Busy.*: (.*)/;
	print "apache_busy_workers:".$1." ";
	$response->content =~ /Idle.*: (.*)/;
	print "apache_idle_workers:".$1;
} else {
	print $response->error_as_HTML;
}

# FIN
