#!/usr/bin/perl -w

# Copyright - Rolf Poser - rolf@stasolutions.co.za
# 19 May 2004 under the GPL license agreement!
#
# HIGH-SPEED VERSION - requires lynx or wget !!
# If you don't have either, please use the default version.
#
# Version 0.4 - PLEASE SEE README.txt and TUNING.txt for more information.
#
# USAGE:
#
# perl unix_apachestats.pl <hostname>
#
# <hostname> is optional and can be an IP address or host name.
#            If none is given, "localhost" is assumed.
#            The cacti configuration should normally take care of this..
#
# LOCAL SETTINGS:
#
# I've found wget to be the most efficient, but if you're not so fussy
# about speed, and/or would rather stick to lynx, you may change the default
# below:
#

$RETRIEVER="/usr/bin/wget --user-agent=\"ApacheStats\/0.4 wget\/1.8\" -q -O -";
#$RETRIEVER="/usr/bin/lynx -useragent=\"ApacheStats\/0.4 Lynx\/2.8\" -dump";

# Change the following if you have an environment variable of "http_proxy"
# that interferes with your direct access to the web server in question.
# The symptoms are that the ACL on the server disallows you access because
# you are connecting via a proxy server:

delete $ENV{'HTTP_PROXY'};
delete $ENV{'http_proxy'};

#
# YOU SHOULDN"T NEED TO CHANGE ANYTHING BEYOND THIS POINT..
#

# First get hold of any supplied hostname, otherwise set to "localhost"

my $hostname = $ARGV[0];

chomp $hostname;

if ($hostname eq '') {
        $hostname = "localhost";
}

# Set the query URL:

$URL = "http:\/\/".$hostname."\/server-status?auto";

# Run the query:

$output = `$RETRIEVER $URL`;

# Parse the output and put out the stats to STDOUT:

$output =~ /Total Accesses: (.*)/; 
print "apache_total_hits:".$1." "; 
$output =~ /Total kBytes: (.*)/; 
print "apache_total_kbytes:".$1." ";
$output =~ /Busy.*: (.*)/;
print "apache_busy_workers:".$1." ";
$output =~ /Idle.*: (.*)/;
print "apache_idle_workers:".$1;

# FIN
